#!/usr/bin/perl
#
# Automagically reports all .c/.h-files in current directory and all subfolders, which 
# are listed as objects in makefile and are missing in $ProjectFile.
# See updateProjectFiles.sh for example usage.
#

my $Error;
my $ProjectFile = shift(@ARGV);
my $FilePath = shift(@ARGV);

unless ( -e $ProjectFile) {
  $Error .= "  ERROR: missing file PROJECT.files - Candidates: ".`ls *.files`;
}
unless ( -e $FilePath) {
  $Error .= "  ERROR: FILE_PATH to add is missing\n";
}

if ($Error) {
  print "$0 PROJECT.files FILE_PATH\n";
  print $Error."\n";
  exit 10;
}

if (substr($FilePath, 0, 2) eq './') { substr($FilePath, 0, 2) = ''; } 

my $LastSlashPos = rindex($FilePath, "/") + 1;
my $File = substr($FilePath, $LastSlashPos);
my $Path = substr($FilePath, 0, $LastSlashPos);
my $ObjectFile = $File;
$ObjectFile =~ s/\.c/\\\.o/;
$ObjectFile =~ s/\.h/\\\.o/;

my $ObjectExistsInMakefile  = `grep ' $ObjectFile' makefile`;
my $CMD = "grep '\\-I $Path' makefile";
my $IncludeExistsInMakefile = `$CMD`;

if (0 && (index($FilePath, 'stm32f10x_tim') > -1)) {
  print "$File\n";
  print "$FilePath\n";
  print "\$CMD=='$CMD'\n"; #D
  print "\nExistsInMakefile=='$ExistsInMakefile'\n";
}
my $VPathExistsInMakefile = `grep ' $Path\\:' makefile`;
if ($ObjectExistsInMakefile && ($IncludeExistsInMakefile || $VPathExistsInMakefile) ) {
  #print "\$CMD='$CMD'"; #D
  #print "\$IncludeExistsInMakefile==$IncludeExistsInMakefile;\n"; #D
  
  my $ExistsInProject = `grep $File $ProjectFile`;
  unless ($ExistsInProject) {
    print "$FilePath\n";
  }
}
